<?php
namespace Teknisa\FIS\Modules\Acessorias\Services;

//require("../Utilities/Agendamento.php");

use Teknisa\FIS\Modules\Acessorias\Factories\Fis41200ConfiguracaoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\DateUtil;
use Teknisa\Libs\Util\NewCode;

class Fis41200ConfiguracaoService {

    public function __construct(Environment $environment, Fis41200ConfiguracaoFactory $Fis41200ConfiguracaoFactory, NewCode $newCode
    ) {
        $this->environment = $environment;
        $this->Fis41200ConfiguracaoFactory = $Fis41200ConfiguracaoFactory;
        $this->newCode                  = $newCode;
    }

    
    public function saveContatos($row){
        try {    
            if($row['CDEMPRESA'] == 'T'){
                $empresaArray = $this->Fis41200ConfiguracaoFactory->getEmpresas($row);
            } else {
                $i = 0;
                foreach($row['CDEMPRESA'] as $empresa){
                    $empresaArray[$i]['CDEMPRESA'] =  $empresa;
                    $i++;
                }
            }
            $row['NRORG'] = $this->environment->getNrOrgTrab();
            //var_dump($empresaArray);
            
            foreach($empresaArray as $empresa ){
                
                $row["CDEMPRESA"] = $empresa['CDEMPRESA'];
                //var_dump($row);
                
                $verificaContaApurac = $this->Fis41200ConfiguracaoFactory->verificaContaApurac($row);
                
                if($row['__is_new'] == true){
                    if(empty($verificaContaApurac)){
                        $row["NRSEQUCONT"] = $this->newCode->getCodeByTableName('NRSEQUCONT', $row["NRORG"], 1, 10);
                        $this->Fis41200ConfiguracaoFactory->insertContaApurac($row);
                    } 
                } else {
                    if(empty($verificaContaApurac)){
                        $row["NRSEQUCONT"] = $this->newCode->getCodeByTableName('NRSEQUCONT', $row["NRORG"], 1, 10);
                        $this->Fis41200ConfiguracaoFactory->insertContaApurac($row);
                    } else if(!empty($verificaContaApurac)){
                        $this->Fis41200ConfiguracaoFactory->updateContaApurac($verificaContaApurac[0], $row);
                    }
                }
            }
        } catch(\Exception $e) {
            //
            throw $e;
        }
    }

}